(*
  DTween

  The MIT License

  Copyright (c) 2011 Lyna, http://twc.xrea.jp/

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in
  all copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
  THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  THE SOFTWARE.

  ----------

  XV

    Ver.0.1  11/08/09  
    Ver.0.2  11/08/12  TEasing.ElasticEaseOut̃oOC
*)
unit DTween.Easing;

interface

type
  { C[WO֐̃vg^Cvł
    Ɠ`ł΃\bhQƈȊOɊ֐CX^X\bhłOK
    t: oߎ }
  TEasingFunc = reference to function(const t, b, c, d: Extended): Extended;

  { eC[WO֐ێNXł }
  TEasing = class
  public
    { 𐧌䂷֐QłB
      eɂẮuAS C[WOvƂŃOOԂ񑁂ł
      ͂̕ӎQ
      http://hosted.zeh.com.br/tweener/docs/en-us/misc/transitions.html
      http://mtl.recruit.co.jp/sandbox/terai/blog/tweenTypeViewer/

      Ȃ݂Linear͂̂܂TEasingFunč`ɂȂĂ܂A
      BacknElasticn̓p[^邽߁ATEasingFuncԂ֐ɂȂĂ܂
      gp̓p[^ȗꍇł()K{ł̂Œӂĉ }

    class function Linear(const t, b, c, d: Extended): Extended; static;

    class function SineEaseIn(const t, b, c, d: Extended): Extended; static;
    class function SineEaseInOut(const t, b, c, d: Extended): Extended; static;
    class function SineEaseOut(const t, b, c, d: Extended): Extended; static;
    class function SineEaseOutIn(const t, b, c, d: Extended): Extended; static;

    class function QuadEaseIn(const t, b, c, d: Extended): Extended; static;
    class function QuadEaseInOut(const t, b, c, d: Extended): Extended; static;
    class function QuadEaseOut(const t, b, c, d: Extended): Extended; static;
    class function QuadEaseOutIn(const t, b, c, d: Extended): Extended; static;

    class function CircEaseIn(const t, b, c, d: Extended): Extended; static;
    class function CircEaseInOut(const t, b, c, d: Extended): Extended; static;
    class function CircEaseOut(const t, b, c, d: Extended): Extended; static;
    class function CircEaseOutIn(const t, b, c, d: Extended): Extended; static;

    class function CubicEaseIn(const t, b, c, d: Extended): Extended; static;
    class function CubicEaseInOut(const t, b, c, d: Extended): Extended; static;
    class function CubicEaseOut(const t, b, c, d: Extended): Extended; static;
    class function CubicEaseOutIn(const t, b, c, d: Extended): Extended; static;

    class function ExpoEaseIn(const t, b, c, d: Extended): Extended; static;
    class function ExpoEaseInOut(const t, b, c, d: Extended): Extended; static;
    class function ExpoEaseOut(const t, b, c, d: Extended): Extended; static;
    class function ExpoEaseOutIn(const t, b, c, d: Extended): Extended; static;

    class function QuartEaseIn(const t, b, c, d: Extended): Extended; static;
    class function QuartEaseInOut(const t, b, c, d: Extended): Extended; static;
    class function QuartEaseOut(const t, b, c, d: Extended): Extended; static;
    class function QuartEaseOutIn(const t, b, c, d: Extended): Extended; static;

    class function QuintEaseIn(const t, b, c, d: Extended): Extended; static;
    class function QuintEaseInOut(const t, b, c, d: Extended): Extended; static;
    class function QuintEaseOut(const t, b, c, d: Extended): Extended; static;
    class function QuintEaseOutIn(const t, b, c, d: Extended): Extended; static;

    class function BackEaseIn(const s:Extended = 1.70158): TEasingFunc; static;
    class function BackEaseInOut(const s:Extended = 1.70158): TEasingFunc; static;
    class function BackEaseOut(const s:Extended = 1.70158): TEasingFunc; static;
    class function BackEaseOutIn(const s:Extended = 1.70158): TEasingFunc; static;

    class function BounceEaseIn(const t, b, c, d: Extended): Extended; static;
    class function BounceEaseInOut(const t, b, c, d: Extended): Extended; static;
    class function BounceEaseOut(const t, b, c, d: Extended): Extended; static;
    class function BounceEaseOutIn(const t, b, c, d: Extended): Extended; static;

    class function ElasticEaseIn(const a: Extended = 0; const p: Extended = 0): TEasingFunc; static;
    class function ElasticEaseInOut(const a: Extended = 0; const p: Extended = 0): TEasingFunc; static;
    class function ElasticEaseOut(const a: Extended = 0; const p: Extended = 0): TEasingFunc; static;
    class function ElasticEaseOutIn(const a: Extended = 0; const p: Extended = 0): TEasingFunc; static;
  end;

implementation

uses Math;

{ TEasing }

class function TEasing.Linear(const t, b, c, d: Extended): Extended;
begin
  Result := c * t / d + b;
end;

class function TEasing.SineEaseIn(const t, b, c, d: Extended): Extended;
begin
  Result := -c * Cos(t / d * (Pi / 2)) + c + b;
end;

class function TEasing.SineEaseInOut(const t, b, c, d: Extended): Extended;
begin
  Result := -c / 2 * (Cos(Pi * t / d) - 1) + b;
end;

class function TEasing.SineEaseOut(const t, b, c, d: Extended): Extended;
begin
  Result := c * Sin(t / d * (Pi / 2)) + b;
end;

class function TEasing.SineEaseOutIn(const t, b, c, d: Extended): Extended;
begin
  if t < d / 2 then
    Result := (c / 2) * Sin((t * 2) / d * (Pi / 2)) + b
  else
    Result := -(c / 2) * Cos((t * 2 - d) / d * (Pi / 2)) + (c / 2) + (b + c / 2);
end;

class function TEasing.QuadEaseIn(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / d;
  Result := c * t1 * t1 + b;
end;

class function TEasing.QuadEaseInOut(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / (d / 2);
  if t1 < 1 then
    Result := c / 2 * t1 * t1 + b
  else
  begin
    t1 := t1 - 1;
    Result := -c / 2 * (t1 * (t1 - 2) - 1) + b;
  end
end;

class function TEasing.QuadEaseOut(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / d;
  Result := -c * t1 * (t1 - 2) + b;
end;

class function TEasing.QuadEaseOutIn(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  if t < d / 2 then
  begin
    t1 := t * 2 / d;
    Result := -(c / 2) * t1 * (t1 - 2) + b;
  end
  else begin
    t1 := (t * 2 - d) / d;
    Result := (c / 2) * t1 * t1 + (b + c / 2);
  end;
end;

class function TEasing.CircEaseIn(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / d;
  Result := -c * (Sqrt(1 - t1 * t1) - 1) + b;
end;

class function TEasing.CircEaseInOut(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / (d / 2);
  if t1 < 1 then
    Result := -c / 2 * (Sqrt(1 - t1 * t1) - 1) + b
  else
  begin
    t1 := t1 - 2;
    Result := c / 2 * (Sqrt(1 - t1 * t1) + 1) + b;
  end;
end;

class function TEasing.CircEaseOut(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / d - 1;
  Result := c * Sqrt(1 - t1 * t1) + b;
end;

class function TEasing.CircEaseOutIn(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  if t < d / 2 then
  begin
    t1 := (t * 2) / d - 1;
    Result := (c / 2) * Sqrt(1 - t1 * t1) + b
  end
  else begin
    t1 := (t * 2 - d) / d;
    Result := -(c / 2) * (Sqrt(1 - t1 * t1) - 1) + (b + c / 2);
  end;
end;

class function TEasing.CubicEaseIn(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / d;
  Result := c * t1 * t1 * t1 + b;
end;

class function TEasing.CubicEaseInOut(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / (d / 2);
  if t1 < 1 then
    Result := c / 2 * t1 * t1 * t1 + b
  else
  begin
    t1 := t1 - 2;
    Result := c / 2 * (t1 * t1 * t1 + 2) + b;
  end;
end;

class function TEasing.CubicEaseOut(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / d - 1;
  Result := c * (t1 * t1 * t1 + 1) + b;
end;

class function TEasing.CubicEaseOutIn(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  if t < d / 2 then
  begin
    t1 := t * 2 / d - 1;
    Result := c / 2 * (t1 * t1 * t1 + 1) + b;
  end
  else begin
    t1 := (t * 2 - d) / d;
    Result := c / 2 * t1 * t1 * t1 + b + c / 2;
  end;
end;

class function TEasing.ExpoEaseIn(const t, b, c, d: Extended): Extended;
begin
  if t = 0 then
    Result := b
  else
    Result := c * Power(2, 10 * (t / d - 1)) + b;
end;

class function TEasing.ExpoEaseInOut(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  if t = 0 then Exit(b);
  if t = d then Exit(b + c);
  t1 := t / (d / 2);
  if t1 < 1 then Exit(c / 2 * Power(2, 10 * (t1 - 1)) + b);
  t1 := t1 - 1;
  Result := c / 2 * (2 - Power(2, -10 * t1)) + b;
end;

class function TEasing.ExpoEaseOut(const t, b, c, d: Extended): Extended;
begin
  if t = d then
    Result := b + c
  else
    Result := c * (1 - Power(2, -10 * t / d)) + b;
end;

class function TEasing.ExpoEaseOutIn(const t, b, c, d: Extended): Extended;
begin
  if t < d / 2 then
  begin
    if t * 2 = d then
      Result := b + c / 2
    else
      Result := c / 2 * (1 - Power(2, -10 * t * 2 / d)) + b;
  end
  else begin
    if t * 2 - d = 0 then
      Result := b + c / 2
    else
      Result := c / 2 * Power(2, 10 * ((t * 2 - d) / d - 1)) + b + c / 2;
  end;
end;

class function TEasing.QuartEaseIn(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / d;
  Result := c * t1 * t1 * t1 * t1 + b;
end;

class function TEasing.QuartEaseInOut(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / (d / 2);
  if t1 < 1 then
    Result := c / 2 * t1 * t1 * t1 * t1 + b
  else
  begin
    t1 := t1 - 2;
    Result := -c / 2 * (t1 * t1 * t1 * t1 - 2) + b;
  end;
end;

class function TEasing.QuartEaseOut(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / d - 1;
  Result := -c * (t1 * t1 * t1 * t1 - 1) + b;
end;

class function TEasing.QuartEaseOutIn(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  if t < d / 2 then
  begin
    t1 := (t * 2) / d - 1;
    Result := -(c / 2) * (t1 * t1 * t1 * t1 - 1) + b;
  end
  else begin
    t1 := (t * 2 - d) / d;
    Result := (c / 2) * t1 * t1 * t1 * t1 + (b + c / 2);
  end;
end;

class function TEasing.QuintEaseIn(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / d;
  Result := c * t1 * t1 * t1 * t1 * t1 + b;
end;

class function TEasing.QuintEaseInOut(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / (d / 2);
  if t1 < 1 then
    Result := c / 2 * t1 * t1 * t1 * t1 * t1 + b
  else begin
    t1 := t1 - 2;
    Result := c / 2 * (t1 * t1 * t1 * t1 * t1 + 2) + b;
  end;
end;

class function TEasing.QuintEaseOut(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / d - 1;
  Result := c * (t1 * t1 * t1 * t1 * t1 + 1) + b;
end;

class function TEasing.QuintEaseOutIn(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  if t < d / 2 then
  begin
    t1 := (t * 2) / d - 1;
    Result := (c / 2) * (t1 * t1 * t1 * t1 * t1 + 1) + b;
  end
  else begin
    t1 := (t * 2 - d) / d;
    Result := (c / 2) * t1 * t1 * t1 * t1 * t1 + (b + c / 2);
  end;
end;

class function TEasing.BackEaseIn(const s: Extended): TEasingFunc;
begin
  Result :=
    function(const t, b, c, d: Extended): Extended
    var
      t1: Extended;
    begin
      t1 := t / d;
      Result := c * t1 * t1 * ((s + 1) * t1 - s) + b;
    end
end;

class function TEasing.BackEaseInOut(const s: Extended): TEasingFunc;
begin
  Result :=
    function(const t, b, c, d: Extended): Extended
    var
      t1: Extended;
    begin
      t1 := t / (d / 2);
      if t1 < 1 then
        Result := c / 2 * (t1 * t1 * (((s * 1.525) + 1) * t1 - s * 1.525)) + b
      else begin
        t1 := t1 - 2;
        Result := c / 2 * (t1 * t1 * (((s * 1.525) + 1) * t1 + s * 1.525) + 2) + b;
      end;
    end;
end;

class function TEasing.BackEaseOut(const s: Extended): TEasingFunc;
begin
  Result :=
    function(const t, b, c, d: Extended): Extended
    var
      t1: Extended;
    begin
      t1 := t / d - 1;
      Result := c * (t1 * t1 * ((s + 1) * t1 + s) + 1) + b;
    end;
end;

class function TEasing.BackEaseOutIn(const s: Extended): TEasingFunc;
begin
  Result :=
    function(const t, b, c, d: Extended): Extended
    var
      t1: Extended;
    begin
      if t < d / 2 then
      begin
        t1 := (t * 2) / d - 1;
        Result := (c / 2) * (t1 * t1 * ((s + 1) * t1 + s) + 1) + b;
      end
      else begin
        t1 := (t * 2 - d) / d;
        Result := (c / 2) * t1 * t1 * ((s + 1) * t1 - s) + (b + c / 2);
      end;
    end;
end;

class function TEasing.BounceEaseIn(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := (d - t) / d;
  if t1 < (1 / 2.75) then
  begin
    Exit(c - (c * (7.5625 * t1 * t1)) + b);
  end;
  if t1 < (2 / 2.75) then
  begin
    t1 := t1 - 1.5 / 2.75;
    Exit(c - (c * (7.5625 * t1 * t1 + 0.75)) + b);
  end;
  if t1 < 2.5 / 2.75 then
  begin
    t1 := t1 - 2.25 / 2.75;
    Exit(c - (c * (7.5625 * t1 * t1 + 0.9375)) + b);
  end;
  t1 := t1 - 2.625 / 2.75;
  Result := c - (c * (7.5625 * t1 * t1 + 0.984375)) + b;
end;

class function TEasing.BounceEaseInOut(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  if t < d / 2 then
  begin
    t1 := (d - t * 2) / d;
    if t1 < 1 / 2.75 then
    begin
      Exit((c - (c * (7.5625 * t1 * t1))) * 0.5 + b);
    end;
    if t1 < 2 / 2.75 then
    begin
      t1 := t1 - 1.5 / 2.75;
      Exit((c - (c * (7.5625 * t1 * t1 + 0.75))) * 0.5 + b);
    end;
    if t1 < 2.5 / 2.75 then
    begin
      t1 := t1 - 2.25 / 2.75;
      Exit((c - (c * (7.5625 * t1 * t1 + 0.9375))) * 0.5 + b);
    end;
    t1 := t1 - 2.625 / 2.75;
    Result := (c - (c * (7.5625 * t1 * t1 + 0.984375))) * 0.5 + b;
  end
  else begin
    t1 := (t * 2 - d) / d;
    if t1 < 1 / 2.75 then
    begin
      Exit((c * (7.5625 * t1 * t1)) * 0.5 + c * 0.5 + b);
    end;
    if t1 < 2 / 2.75 then
    begin
      t1 := t1 - 1.5 / 2.75;
      Exit((c * (7.5625 * t1 * t1 + 0.75)) * 0.5 + c * 0.5 + b);
    end;
    if t1 < 2.5 / 2.75 then
    begin
      t1 := t1 - 2.25 / 2.75;
      Exit((c * (7.5625 * t1 * t1 + 0.9375)) * 0.5 + c * 0.5 + b);
    end;
    t1 := t1 - 2.625 / 2.75;
    Result := (c * (7.5625 * t1 * t1 + 0.984375)) * 0.5 + c * 0.5 + b;
  end;
end;

class function TEasing.BounceEaseOut(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / d;
  if t1 < 1 / 2.75 then
  begin
    Exit(c * (7.5625 * t1 * t1) + b);
  end;
  if t1 < 2 / 2.75 then
  begin
    t1 := t1 - 1.5 / 2.75;
    Exit(c * (7.5625 * t1 * t1 + 0.75) + b);
  end;
  if t1 < 2.5 / 2.75 then
  begin
    t1 := t1 - 2.25 / 2.75;
    Exit(c * (7.5625 * t1 * t1 + 0.9375) + b);
  end;
  t1 := t1 - 2.625 / 2.75;
  Result := c * (7.5625 * t1 * t1 + 0.984375) + b;
end;

class function TEasing.BounceEaseOutIn(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  if t < d / 2 then
  begin
    t1 := (t * 2) / d;
    if t1 < 1 / 2.75 then
    begin
      Exit((c / 2) * (7.5625 * t1 * t1) + b);
    end;
    if t1 < 2 / 2.75 then
    begin
      t1 := t1 - 1.5 / 2.75;
      Exit((c / 2) * (7.5625 * t1 * t1 + 0.75) + b);
    end;
    if t1 < 2.5 / 2.75 then
    begin
      t1 := t1 - 2.25 / 2.75;
      Exit((c / 2) * (7.5625 * t1 * t1 + 0.9375) + b);
    end;
    t1 := t1 - 2.625 / 2.75;
    Result := (c / 2) * (7.5625 * t1 * t1 + 0.984375) + b;
  end
  else begin
    t1 := (d - (t * 2 - d)) / d;
    if t1 < 1 / 2.75 then
    begin
      Exit((c / 2) - ((c / 2) * (7.5625 * t1 * t1)) + (b + c / 2));
    end;
    if t1 < 2 / 2.75 then
    begin
      t1 := t1 - 1.5 / 2.75;
      Exit((c / 2) - ((c / 2) * (7.5625 * t1 * t1 + 0.75)) + (b + c / 2));
    end;
    if t1 < 2.5 / 2.75 then
    begin
      t1 := t1 - 2.25 / 2.75;
      Exit((c / 2) - ((c / 2) * (7.5625 * t1 * t1 + 0.9375)) + (b + c / 2));
    end;
    t1 := t1 - 2.625 / 2.75;
    Result := (c / 2) - ((c / 2) * (7.5625 * t1 * t1 + 0.984375)) + (b + c / 2);
  end;
end;

class function TEasing.ElasticEaseIn(const a, p: Extended): TEasingFunc;
begin
  Result :=
    function(const t, b, c, d: Extended): Extended
    var
      _a: Extended;
      _p: Extended;
      s: Extended;
      t1: Extended;
    begin
      if t = 0 then Exit(b);
      t1 := t / d;
      if t1 = 1 then Exit(b + c);
      _a := a;
      _p := p;
      if _p = 0 then
      begin
        _p := d * 0.3;
      end;
      if (_a = 0) or (_a < Abs(c)) then
      begin
        _a := c;
        s := _p / 4;
      end
      else begin
        s := _p / (2 * Pi) * ArcSin(c / _a);
      end;
      t1 := t1 - 1;
      Result := -(_a * Power(2, 10 * t1) * Sin((t1 * d - s) * (2 * Pi) / _p)) + b;
    end;
end;

class function TEasing.ElasticEaseInOut(const a, p: Extended): TEasingFunc;
begin
  Result :=
    function(const t, b, c, d: Extended): Extended
    var
      _a: Extended;
      _p: Extended;
      s: Extended;
      t1: Extended;
    begin
      if t = 0 then Exit(b);
      t1 := t / (d / 2);
      if t1 = 2 then Exit(b + c);
      _a := a;
      _p := p;
      if _p = 0 then
      begin
        _p := d * (0.3 * 1.5);
      end;
      if (_a = 0) or (_a < Abs(c)) then
      begin
        _a := c;
        s := _p / 4;
      end
      else begin
        s := _p / (2 * Pi) * ArcSin(c / _a);
      end;
      t1 := t1 - 1;
      if t1 < 0 then
        Result := -0.5 * (_a * Power(2, 10 * t1) * Sin((t1 * d - s) * (2 * Pi) / _p)) + b
      else
        Result := _a * Power(2, -10 * t1) * Sin((t1 * d - s) * (2 * Pi) / _p) * 0.5 + c + b;
    end
end;

class function TEasing.ElasticEaseOut(const a, p: Extended): TEasingFunc;
begin
  Result :=
    function(const t, b, c, d: Extended): Extended
    var
      _a: Extended;
      _p: Extended;
      s: Extended;
      t1: Extended;
    begin
      if t = 0 then Exit(b);
      t1 := t / d;
      if t1 = 1 then Exit(b + c);
      _a := a;
      _p := p;
      if _p = 0 then
      begin
        _p := d * 0.3;
      end;
      if (_a = 0) or (_a < Abs(c)) then
      begin
        _a := c;
        s := _p / 4;
      end
      else begin
        s := _p / (2 * Pi) * ArcSin(c / _a);
      end;
      Result := _a * Power(2, -10 * t1) * Sin((t1 * d - s) * (2 * Pi) / _p) + c + b;
    end;
end;

class function TEasing.ElasticEaseOutIn(const a, p: Extended): TEasingFunc;
begin
  Result :=
    function(const t, b, c, d: Extended): Extended
    var
      _a: Extended;
      _p: Extended;
      s: Extended;
      c1: Extended;
      t1: Extended;
    begin
      c1 := c / 2;
      _a := a;
      _p := p;
      if t < d / 2 then
      begin
        t1 := t * 2;
        if t1 = 0 then Exit(b);
        t1 := t1 / d;
        if t1 = 1 then Exit(b + c1);
        if _p = 0 then
        begin
          _p := d * 0.3;
        end;
        if (_a = 0) or (_a < Abs(c1)) then
        begin
          _a := c1;
          s := _p / 4;
        end
        else begin
          s := _p / (2 * Pi) * ArcSin(c1 / _a);
        end;
        Result := _a * Power(2, -10 * t1) * Sin((t1 * d - s) * (2 * Pi) / _p) + c1 + b;
      end
      else begin
        t1 := t * 2 - d;
        if t1 = 0 then Exit(b + c1);
        t1 := t1 / d;
        if t1 = 1 then Exit(b + c1 + c1);
        if _p = 0 then
        begin
          _p := d * 0.3;
        end;
        if (_a = 0) or (_a < Abs(c1)) then
        begin
          _a := c1;
          s := _p / 4;
        end
        else begin
          s := _p / (2 * Pi) * ArcSin(c1 / _a);
        end;
        t1 := t1 - 1;
        Result := -(_a * Power(2, 10 * t1) * Sin((t1 * d - s) * (2 * Pi) / _p)) + (b + c1);
      end;
    end;
end;

end.
