unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Rtti, TypInfo, DTween, DTween.Easing;

type
  TForm1 = class(TForm)
    btnSlideLeft: TButton;
    btnSlideRight: TButton;
    btnPlay: TButton;
    btnPause: TButton;
    btnBreak: TButton;
    pbGraph: TPaintBox;
    imgDragMe: TImage;
    pnColor1: TPanel;
    btnRingCenter: TButton;
    cbGraph: TComboBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    pnColor2: TPanel;
    pnColor3: TPanel;
    pnColor4: TPanel;
    shpCircle: TShape;
    ListBox1: TListBox;
    procedure btnPlayClick(Sender: TObject);
    procedure btnPauseClick(Sender: TObject);
    procedure btnRingCenterClick(Sender: TObject);
    procedure cbGraphSelect(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure pbGraphPaint(Sender: TObject);
    procedure pnColorMouseEnter(Sender: TObject);
    procedure pnColorMouseLeave(Sender: TObject);
    procedure btnBreakClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure imgDragMeMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure imgDragMeMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure imgDragMeMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnSlideLeftClick(Sender: TObject);
    procedure btnSlideRightClick(Sender: TObject);
    procedure RadioButtonClick(Sender: TObject);
  private
    { Private 錾 }
  type
    TViewIndex = 0..3;
  var
    FDragOrgX: Integer;
    FDragOrgY: Integer;
    FGraphBuffer: TBitmap;
    FRingButtons: array[0..7] of TButton;
    FViewIndex: TViewIndex;
    procedure RingButtonClick(Sender: TObject);
  public
    { Public 錾 }
    tween: ITween;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  size: TSize;
begin
  imgDragMe.Canvas.Brush.Color := clFuchsia;
  imgDragMe.Canvas.FillRect(imgDragMe.ClientRect);
  imgDragMe.Canvas.Pen.Color := clBlack;
  imgDragMe.Canvas.Pen.Width := 2;
  imgDragMe.Canvas.Brush.Color := clWhite;
  imgDragMe.Canvas.Ellipse(imgDragMe.ClientRect);
  size := imgDragMe.Canvas.TextExtent('Drag me');
  imgDragMe.Canvas.TextOut((imgDragMe.Width-size.cx) div 2, (imgDragMe.Height-size.cy) div 2, 'Drag me');
  FDragOrgX := imgDragMe.Left;
  FDragOrgY := imgDragMe.Top;

  FViewIndex := 0;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FGraphBuffer.Free;
end;

{ gDC[̍Đƈꎞ~̃f }

procedure TForm1.btnPlayClick(Sender: TObject);
begin
  if tween = nil then
  begin
    tween := TTween.Parallel([
      TTween.Serial([
        TTween.TweenTo(shpCircle, ['$Left', 129], 1000, TEasing.SineEaseInOut),
        TTween.TweenFrom(shpCircle, ['$Left', 129], 1000, TEasing.SineEaseInOut),
        TTween.TweenTo(shpCircle, ['$Left', 129], 1000, TEasing.SineEaseInOut),
        TTween.TweenFrom(shpCircle, ['$Left', 129], 1000, TEasing.SineEaseInOut)
      ]),
      TTween.TweenTo(shpCircle, ['$Top', 314], 4000, TEasing.Linear)
    ]);
    tween.StopOnComplete := False;
  end;
  tween.Play;
end;

procedure TForm1.btnPauseClick(Sender: TObject);
begin
  if tween <> nil then
    tween.Pause;
end;

{ OR}hǂӂƏoďf }

procedure TForm1.btnRingCenterClick(Sender: TObject);
const
  D = 80;
  DirX: array[0..7] of Integer = (-1, 0, 1, 1, 1, 0, -1, -1);
  DirY: array[0..7] of Integer = (-1, -1, -1, 0, 1, 1, 1, 0);
var
  i: Integer;
  x, y: Integer;
  //t: ITween;
begin
  btnRingCenter.Enabled := False;
  for i := Low(FRingButtons) to High(FRingButtons) do
  begin
    if FRingButtons[i] = nil then
    begin
      FRingButtons[i] := TButton.Create(Self);
      FRingButtons[i].Parent := TButton(Sender).Parent;
      FRingButtons[i].Width := 25;
      FRingButtons[i].Height := 25;
    end;
    FRingButtons[i].Left := btnRingCenter.Left + (btnRingCenter.Width - FRingButtons[i].Width) div 2;
    FRingButtons[i].Top := btnRingCenter.Top + (btnRingCenter.Height - FRingButtons[i].Height) div 2;
    FRingButtons[i].OnClick := RingButtonClick;
    FRingButtons[i].Enabled := True;
    FRingButtons[i].Visible := True;
    if Abs(DirX[i]) - Abs(DirY[i]) = 0 then
    begin
      x := Trunc(FRingButtons[i].Left + DirX[i] * D * 0.7);
      y := Trunc(FRingButtons[i].Top + DirY[i] * D * 0.7);
    end
    else begin
      x := FRingButtons[i].Left + DirX[i] * D;
      y := FRingButtons[i].Top + DirY[i] * D;
    end;

    // PTweenŎꍇ
    TTween.Tween(FRingButtons[i], [], ['Left', x, 'Top', y], 500, TEasing.BackEaseOut()).Play;
    {
    // ʂTweenŎꍇ
    // Oɐݒ肵̂邽߁AOverwrite:=FalseK{)
    TTween.Tween(FRingButtons[i], 'Left', FRingButtons[i].Left, x, 500, TEasing.BackEaseOut()).Play;
    t := TTween.Tween(FRingButtons[i], 'Top', FRingButtons[i].Top, y, 500, TEasing.BackEaseOut());
    t.Overwrite := False;
    t.Play;

    // ParalellŎꍇ
    // ParallelłOverwriteɂ閳Ȃ߁AOverwrite:=False͕sv
    TTween.Parallel([
      TTween.Tween(FRingButtons[i], 'Left', FRingButtons[i].Left, x, 500, TEasing.BackEaseOut()),
      TTween.Tween(FRingButtons[i], 'Top', FRingButtons[i].Top, y, 500, TEasing.BackEaseOut())
    ]).Play;
    }
  end;
end;

procedure TForm1.RingButtonClick(Sender: TObject);
var
  i: Integer;
  x, y: Integer;
  tweens: array[0..7] of ITween;
  t: ITween;
begin
  for i := Low(FRingButtons) to High(FRingButtons) do
  begin
    FRingButtons[i].OnClick := nil;
    FRingButtons[i].Enabled := False;
    x := btnRingCenter.Left + (btnRingCenter.Width - FRingButtons[i].Width) div 2;
    y := btnRingCenter.Top + (btnRingCenter.Height - FRingButtons[i].Height) div 2;
    tweens[i] := TTween.Parallel([
      TTween.Tween(FRingButtons[i], 'Left', FRingButtons[i].Left, x, 500, TEasing.BackEaseIn()),
      TTween.Tween(FRingButtons[i], 'Top', FRingButtons[i].Top, y, 500, TEasing.BackEaseIn())
    ]);
  end;
  t := TTween.Parallel(tweens);
  t.OnComplete :=
    procedure(Tween: ITween)
    var
      i: Integer;
    begin
      for i := Low(FRingButtons) to High(FRingButtons) do
        FRingButtons[i].Visible := False;
      btnRingCenter.Enabled := True
    end;
  t.Play;
end;

{ hbOČɖ߂f }

var
  IsDragging: Boolean;
  PrevX, PrevY: Integer;
procedure TForm1.imgDragMeMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button <> mbLeft then Exit;
  TTween.Abort(Sender);
  IsDragging := True;
  PrevX := X;
  PrevY := Y;
end;

procedure TForm1.imgDragMeMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  pt: TPoint;
begin
  if not IsDragging then Exit;

  pt := imgDragMe.Parent.ScreenToClient(imgDragMe.ClientToScreen(Point(X, Y)));
  imgDragMe.Left := pt.X-PrevX;
  imgDragMe.Top := pt.Y-PrevY;
end;

procedure TForm1.imgDragMeMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if not IsDragging then Exit;
  IsDragging := False;

  TTween.Tween(Sender, [], ['Left', FDragOrgX, 'Top', FDragOrgY], 1000, TEasing.ElasticEaseOut()).Play;
end;

{ Xg\ɂAgւčēx\܂
  Xgɂ̓TvƂăgDC[\ȃvpeB񋓂܂ }

procedure TForm1.RadioButtonClick(Sender: TObject);
var
  t1, t2: ITween;
begin
  t1 := TTween.TweenTo(ListBox1, ['Height', 0], 500, TEasing.BackEaseIn());
  t1.OnComplete :=
    procedure(Tween: ITween)
    var
      i, viewIdx: Integer;
      ctx: TRttiContext;
      typ: TRttiType;
      prop: TRttiProperty;
      cnt: Integer;
    begin
      ListBox1.Clear;
      ListBox1.Items.Add('// gDC[\ȃvpeBꗗ');
      viewIdx := StrToInt(TRadioButton(Sender).Name[Length(TRadioButton(Sender).Name)])-1;
      ctx := TRttiContext.Create;
      for i := 0 to ControlCount-1 do
      begin
        if Controls[i].Tag <> viewIdx then Continue;
        typ := ctx.GetType(Controls[i].ClassType);
        if typ = nil then Continue;
        cnt := 0;
        ListBox1.Items.Add(Format('%s = class(%s)', [typ.Name, Controls[i].ClassParent.ClassName]));
        for prop in typ.GetProperties do
        begin
          if not (prop.Visibility in [mvPublic, mvPublished]) then Continue;
          if not prop.IsReadable or not prop.IsWritable then Continue;
          if prop.PropertyType.TypeKind = tkInteger then
          begin
            ListBox1.Items.Add(Format('  property %s: %s;', [prop.Name, prop.PropertyType.Name]));
            Inc(cnt);
          end;
        end;
        if cnt = 0 then
        begin
          ListBox1.Items[ListBox1.Items.Count-1] := ListBox1.Items[ListBox1.Items.Count-1] + ';';
        end
        else begin
          ListBox1.Items.Add('end;');
        end;
      end;
    end;
  t2 := TTween.Delay(200, 0,
    TTween.Tween(ListBox1, ['Height', 0], ['Height', 370], 500, TEasing.BackEaseOut()));
  TTween.Serial([t1, t2]).Play;
end;

{ Fωf }

const
  PanelColors: array[0..3] of TColor = (clAqua, clFuchsia, clYellow, clBlack);
procedure TForm1.pnColorMouseEnter(Sender: TObject);
var
  cl: TColor;
  t: ITween;
begin
  cl := PanelColors[StrToInt(TPanel(Sender).Name[8])-1];
  t := TTween.TweenTo(Sender, 'Color', cl, 200, TEasing.SineEaseIn);
  t.OnUpdate :=
    procedure(Tween: ITween)
    begin
      TPanel(Sender).Caption := ColorToString(TPanel(Sender).Color);
    end;
  t.Play;
end;

procedure TForm1.pnColorMouseLeave(Sender: TObject);
var
  t: ITween;
begin
  t := TTween.TweenTo(Sender, 'Color', clBtnFace, 1000, TEasing.SineEaseOut);
  t.OnUpdate :=
    procedure(Tween: ITween)
    begin
      TPanel(Sender).Caption := ColorToString(TPanel(Sender).Color);
    end;
  t.Play;
end;

{ C[WO֐OtƂĕ\f }

var
  Drawing: Integer = 0;
procedure TForm1.cbGraphSelect(Sender: TObject);
var
  t: ITween;
  prevX, prevY: Integer;
  easing: TEasingFunc;
begin
  case cbGraph.ItemIndex of
    0: easing := TEasing.Linear;
    1: easing := TEasing.SineEaseIn;
    2: easing := TEasing.SineEaseOut;
    3: easing := TEasing.SineEaseInOut;
    4: easing := TEasing.SineEaseOutIn;
    5: easing := TEasing.QuadEaseIn;
    6: easing := TEasing.QuadEaseOut;
    7: easing := TEasing.QuadEaseInOut;
    8: easing := TEasing.QuadEaseOutIn;
    9: easing := TEasing.CircEaseIn;
    10: easing := TEasing.CircEaseOut;
    11: easing := TEasing.CircEaseInOut;
    12: easing := TEasing.CircEaseOutIn;
    13: easing := TEasing.CubicEaseIn;
    14: easing := TEasing.CubicEaseOut;
    15: easing := TEasing.CubicEaseInOut;
    16: easing := TEasing.CubicEaseOutIn;
    17: easing := TEasing.ExpoEaseIn;
    18: easing := TEasing.ExpoEaseOut;
    19: easing := TEasing.ExpoEaseInOut;
    20: easing := TEasing.ExpoEaseOutIn;
    21: easing := TEasing.QuartEaseIn;
    22: easing := TEasing.QuartEaseOut;
    23: easing := TEasing.QuartEaseInOut;
    24: easing := TEasing.QuartEaseOutIn;
    25: easing := TEasing.QuintEaseIn;
    26: easing := TEasing.QuintEaseOut;
    27: easing := TEasing.QuintEaseInOut;
    28: easing := TEasing.QuintEaseOutIn;
    29: easing := TEasing.BackEaseIn();
    30: easing := TEasing.BackEaseOut();
    31: easing := TEasing.BackEaseInOut();
    32: easing := TEasing.BackEaseOutIn();
    33: easing := TEasing.BounceEaseIn;
    34: easing := TEasing.BounceEaseOut;
    35: easing := TEasing.BounceEaseInOut;
    36: easing := TEasing.BounceEaseOutIn;
    37: easing := TEasing.ElasticEaseIn();
    38: easing := TEasing.ElasticEaseOut();
    39: easing := TEasing.ElasticEaseInOut();
    40: easing := TEasing.ElasticEaseOutIn();
    else Exit;
  end;

  if Drawing = 0 then
  begin
    if FGraphBuffer = nil then
    begin
      FGraphBuffer := TBitmap.Create;
      FGraphBuffer.Width := 250;
      FGraphBuffer.Height := 250;
    end;
    FGraphBuffer.Canvas.Brush.Color := clWhite;
    FGraphBuffer.Canvas.FillRect(Rect(0, 0, FGraphBuffer.Width, FGraphBuffer.Height));
    FGraphBuffer.Canvas.Pen.Color := clBlack;
    FGraphBuffer.Canvas.Pen.Width := 1;
    FGraphBuffer.Canvas.Rectangle(Bounds(25, 25, 200, 200));
  end;

  Inc(Drawing);
  prevX := 25;
  prevY := 225;
  t := TTween.Tween(Form1, 'Tag', 225, 25, 1000, easing);
  t.OnUpdate :=
    procedure(Tween: ITween)
    var
      x, y: Integer;
    begin
      FGraphBuffer.Canvas.Pen.Color := clSkyBlue;
      FGraphBuffer.Canvas.Pen.Width := 2;
      FGraphBuffer.Canvas.MoveTo(prevX, prevY);
      x := Round((Tween.Position / Tween.Duration) * 200 + 25);
      y := Form1.Tag;
      FGraphBuffer.Canvas.LineTo(x, y);
      prevX := x;
      prevY := y;
      pbGraph.Invalidate;
    end;
  t.OnComplete :=
    procedure(Tween: ITween)
    begin
      Dec(Drawing);
    end;
  t.Play;
end;

procedure TForm1.pbGraphPaint(Sender: TObject);
begin
  if FGraphBuffer <> nil then
    pbGraph.Canvas.Draw(0, 0, FGraphBuffer);
end;

{ Rg[Ă݂f }

procedure TForm1.btnBreakClick(Sender: TObject);
var
  i, y: Integer;
  t1, t2, t3, t: ITween;
begin
  with TButton(Sender).Parent do
    for i := 0 to ControlCount-1 do
    begin
      y := ClientHeight-Controls[i].Height;
      t1 := TTween.Delay(0, 500, TTween.TweenTo(Controls[i], 'Top', y, 1000, TEasing.BounceEaseOut));
      t2 := TTween.Tween(Controls[i], 'Top', y, ClientHeight, 200, TEasing.SineEaseOut);
      t3 := TTween.TweenFrom(Controls[i], 'Top', -Controls[i].Height, 800, TEasing.QuadEaseOut);
      t := TTween.Serial([t1, t2, t3]);
      if Controls[i].Enabled then
      begin
        t.OnComplete :=
          TFunc<Integer,TTweenEventProc>(
            function(Index: Integer): TTweenEventProc
            begin
              Result :=
                procedure(Tween: ITween)
                begin
                  Controls[Index].Enabled := True;
                end;
            end)(i);
      end;
      Controls[i].Enabled := False;
      t.Play;
    end;
end;

{ XChf
  fAłXChɕʂ̃gDC[n܂肷
  Overwriteʂňʒu邱Ƃ܂AΎw̒ӓ_̃fƂƂŁc }

procedure TForm1.btnSlideLeftClick(Sender: TObject);
var
  i: Integer;
begin
  if FViewIndex <= Low(TViewIndex) then Exit;
  Dec(FViewIndex);
  btnSlideLeft.Enabled := FViewIndex > Low(TViewIndex);
  btnSlideRight.Enabled := FViewIndex < High(TViewIndex);

  for i := 0 to ControlCount-1 do
  begin
    if Controls[i].Tag = -1 then Continue;
    TTween.TweenTo(Controls[i], ['$Left', ClientWidth], 500, TEasing.BackEaseOut()).Play;
  end;
end;

procedure TForm1.btnSlideRightClick(Sender: TObject);
var
  i: Integer;
begin
  if FViewIndex >= High(TViewIndex) then Exit;
  Inc(FViewIndex);
  btnSlideLeft.Enabled := FViewIndex > Low(TViewIndex);
  btnSlideRight.Enabled := FViewIndex < High(TViewIndex);

  for i := 0 to ControlCount-1 do
  begin
    if Controls[i].Tag = -1 then Continue;
    TTween.TweenTo(Controls[i], ['$Left', -ClientWidth], 500, TEasing.BackEaseOut()).Play;
  end;
end;

end.
